{
SUDOKU solver par OutOfRange pour le dfi developpez.com

  ### INDICES DES 81 CASES DE LA GRILLE ###

	Indice de chaque case

	00	09	18	27	36	45	54	63	72
	01	10	19	28	37	46	55	64	73
	02	11	20	29	38	47	56	65	74
	03	12	21	30	39	48	57	66	75
	04	13	22	31	40	49	58	67	76
	05	14	23	32	41	50	59	68	77
	06	15	24	33	42	51	60	69	78
	07	16	25	34	43	52	61	70	79
	08	17	26	35	44	53	62	71	80

	Colonne  laquelle appartient la case
  	            																		              
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08
	00	01	02	03	04	05	06	07	08				                                                  

  Ligne  laquelle appartient la case

  09	09	09	09	09	09	09	09	09
  10	10	10	10	10	10	10	10	10
  11	11	11	11	11	11	11	11	11
  12	12	12	12	12	12	12	12	12
  13	13	13	13	13	13	13	13	13
	14	14	14	14	14	14	14	14	14
  15	15	15	15	15	15	15	15	15
  16	16	16	16	16	16	16	16	16
  17	17	17	17	17	17	17	17	17

  Rgion (carr de 3x3)  laquelle appartient la case

  18	18	18	21	21	21	24	24	24
  18	18	18	21	21	21	24	24	24
  18	18	18	21	21	21	24	24	24
  19	19	19	22	22	22	25	25	25
  19	19	19	22	22	22	25	25	25
  19	19	19	22	22	22	25	25	25
  20	20	20	23	23	23	26	26	26
  20	20	20	23	23	23	26	26	26
  20	20	20	23	23	23	26	26	26


  ### TERMINOLOGIE ###

  CANDIDATS :
  Liste des valeurs (1  9) possibles dans une case

  ELU :
  Candidat seul dans une case, en cours ou en fin de rsolution (la case n'accepte qu'un seul candidat)

  MONARQUE :
  Valeur de la case avant rsolution
  - soit une valeur saisie (menu GRILLE/NOUVELLE)
  - soit une valeur du fichier ouvert (menu GRILLE/OUVRIR)

  ### SAISIE D'UNE GRILLE ###

  La saisie des valeurs incorrecte est bloque
  (si la valeur est absente de l'ensemble des candidats de la case - procdure TMaGrille.MouseMove)

  ### RESOLUTION ###

  La rsolution consiste  liminer les candidats par passes successives
  La grille est rsolue lorsque toutes les cases ne contiennent plus qu'un seul candidat ou un monarque

  Pour ce faire, 2 tapes (unit Unit_Solv):
  - 1re tape: RESOLUTION LOGIQUE
    Consiste  rechercher des combinaisons prdfinies qui permettent d'liminer des candidats
  - 2me tape: RESOLUTION PAR HYPOTHESES
    Dclenche si la rsolution logique choue,  partir de la dernire configuration de la grille
    Des hypothses successives sont alors mises en privilgiant les cases qui offrent le moins de
    possibilits: cases  2 candidats s'il en existe, ou 3 ou 4...
    Une rsolution logique est lance aprs chaque hypothse
    Plusieurs hypothses peuvent tre mises  la suite les unes des autres avec  chaque fois
    lancement d'une rsolution logique, jusqu' rsolution totale.
    La Validit de la grille est teste  chaque tape de rsolution logique
    La grille est conserve avant chaque hypothse de faon  pouvoir revenir, en cas d'hypothse errone,
     la dernire configuration valide et dans ce cas,
    soit on teste le candidat suivant de la dernire case force, si les choix de candidat
    ne sont pas puiss dans cette case,
    soit on revient  l'hypothse prcdente et on teste  nouveau les autres candidats
    de la case s'ils ne sont pas puiss,
    et ainsi de suite...
  Le processus est stopp si la grille n'est pas rsolue au bout d'1 seconde
}

unit Unit_Ppal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, Menus, StrUtils, ExtCtrls, ComCtrls;

type
  TEtatGrille = (Nulle, Nvell, Charg, Solve, Erron);

  TVal = 0..9;                  //valeurs
  TEnsVal = set of TVal;        //ensemble de valeurs (ex: candidats d'une case)

  TZon = (Cln,Lgn,Rgn);         //3 types de zone (colonne, ligne, rgion)
  TiZon = 0..26;                //indices des zones de la grille
                                //(9 colonnes indices 0..8, 9 lignes 9..17, 9 rgions 18..26)

  TCLReg = array [18..26,0..2] of TiZon;
                                //indices des 3 colonnes ou lignes qui parcourent 1 rgion

  TiCaz = -1..80;               //indices des cases de la grille
                                //-1 est utilis en cas par ex de recherche n'ayant pas abouti

  TIndCaz = array [0..26,0..8] of TiCaz;
                                //indices des 9 cases de chacune des 26 zones

  TEnsCaz = set of 0..80;       //ensemble de cases (d'une zone contenant le candidat c, par ex)

  TRCaz = record                //contient les donnes relatives  chaque case
    Monarq:boolean;             //indique si la case est "rvle" pour la rsolution (monarque)
    Cdt:TEnsVal;                //ensemble des candidats de la case
    Err:boolean;                //en cas d'lu dans la case, indique s'il est valide
    Zon:set of TiZon;           //ensemble des 3 zones (colonne,ligne,rgion) auxquelles appartient la case
  end;
  TCaz = array[word] of TRCaz;
  
  TRHypo = record               //contient les donnes relatives aux hypothses mises
    CazH:TiCaz;                 //indice de la case sur laquelle porte l'hypothse
    CdtH:TEnsVal;               //ensemble des valeurs restant  tester dans la case
    CdtS:array[0..81]of TEnsVal;//liste des candidats des 81 cases avant l'hypothse
  end;
  THypo = array[word] of TRHypo;

  TForm1 = class(TForm)
    sb1: TSpeedButton;
    sb2: TSpeedButton;
    sb3: TSpeedButton;
    sb4: TSpeedButton;
    sb5: TSpeedButton;
    sb6: TSpeedButton;
    sb7: TSpeedButton;
    sb8: TSpeedButton;
    sb9: TSpeedButton;
    sb0: TSpeedButton;
    BtnSolve: TBitBtn;
    MainMenu1: TMainMenu;
    MenGrille: TMenuItem;
    MenNouv: TMenuItem;
    MenOuvr: TMenuItem;
    MenQuitt: TMenuItem;
    MenSauve: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PanelModifGrille: TPanel;
    MenVerif: TMenuItem;
    StatusBarAdr: TStatusBar;
    N1: TMenuItem;
    N2: TMenuItem;
    MenResoud: TMenuItem;
    Timer: TTimer;
    PanelRapport: TPanel;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenQuittClick(Sender: TObject);
    procedure MenNouvClick(Sender: TObject);
    procedure MenResoudClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure GererAffichage;
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    { Dclarations prives }
    procedure DefinirZonesDesCases;
    procedure DefinirCasesDesZones;
    procedure DefinirClnLgnDesRegions;
    procedure OuvrirGrille;
    procedure RemplirGrille;
    procedure ViderGrille;
    procedure SauverGrille;

  public
    { Dclarations publiques }
  end;

  TMaGrille = class(TStringGrid)
  protected
    procedure DrawCell(ACol,ARow:Longint;ARect:TRect;AState:TGridDrawState);override;
    procedure MouseMove(Shift:TShiftState;X,Y:Integer);override;
    procedure MouseUp(Button:TMouseButton;Shift:TShiftState;X,Y:Integer);override;
    procedure CMMouseLeave(var Msg:TMessage);message CM_MouseLeave;
    //procdure absente de la classe de base
  end;

  function AjustPath(APath:shortstring;MonControl:TControl):shortstring;
  function PremVal(EnsVal:TEnsVal):Tval;
  function NbVal(EnsVal:TEnsVal):byte;
  function PremCaz(EnsCaz:TEnsCaz):TiCaz;
  function NbCaz(EnsCaz:TEnsCaz):byte;

var
  Form1: TForm1;
  MaGrille:TMaGrille;

  Caz:^TCaz;
  IndCaz:TIndCaz;
  ZoneCaz:array[0..80,0..2]of TiZon; //indices des 3 zones de chaque case
  RegCln,RegLgn:TCLReg; //indices des 3 colonnes et 3 lignes de chaque rgion
  EtatGrille:TEtatGrille;
  JeuEnCours:shortstring;
  EchecReso:boolean;


const
  cr1=1;
  cr2=2;
  cr3=3;
  cr4=4;
  cr5=5;
  cr6=6;
  cr7=7;
  cr8=8;
  cr9=9;
  crx=10;
  cr0=11;

implementation

{$R *.dfm}

uses Unit_Solv, Unit_Test;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$R ncur.Res}
  Screen.Cursors[cr1]:= LoadCursor(HInstance,'1cur');
  Screen.Cursors[cr2]:= LoadCursor(HInstance,'2cur');
  Screen.Cursors[cr3]:= LoadCursor(HInstance,'3cur');
  Screen.Cursors[cr4]:= LoadCursor(HInstance,'4cur');
  Screen.Cursors[cr5]:= LoadCursor(HInstance,'5cur');
  Screen.Cursors[cr6]:= LoadCursor(HInstance,'6cur');
  Screen.Cursors[cr7]:= LoadCursor(HInstance,'7cur');
  Screen.Cursors[cr8]:= LoadCursor(HInstance,'8cur');
  Screen.Cursors[cr9]:= LoadCursor(HInstance,'9cur');
  Screen.Cursors[crx]:= LoadCursor(HInstance,'xcur');
  Screen.Cursors[cr0]:= LoadCursor(HInstance,'0cur');

  MaGrille:=TMaGrille.Create(Form1);
  with Magrille do
  begin
    Parent:=Form1;
    ColCount:=9;
    DefaultColWidth:=31;
    DefaultDrawing:=true;
    DefaultRowHeight:=31;
    FixedCols:=0;
    FixedRows:=0;
    Font.Height:=-29;
    Font.Name:='Courier New';
    Font.Style:=[fsBold];
    Height:=291;
    Left:=10;
    RowCount:=9;
    ScrollBars:=ssNone;
    Top:=10;
    Width:=291;
    DoubleBuffered:=true;
    Cursor:=cr0;
  end;

  new(Caz);

  PanelRapport.Font:=StatusBarAdr.Font;

  OpenDialog.InitialDir:=extractfilepath(paramstr(0));
  SaveDialog.InitialDir:=extractfilepath(paramstr(0));
  OpenDialog.Filter:='Fichiers texte (*.txt)|*.TXT';
  SaveDialog.Filter:='Fichiers texte (*.txt)|*.TXT';
  SaveDialog.FileName:='SUDOKU1.txt';

  DefinirZonesDesCases;
  DefinirCasesDesZones;
  DefinirClnLgnDesRegions;
  EtatGrille:=Nulle;
  GererAffichage;
  ViderGrille;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  dispose(Caz);
end;

procedure TMaGrille.DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);
begin
  with MaGrille.Canvas do
  begin
    case Caz^[ACol*9+ARow].Err of
    true : Font.Color:=$003235B4;
    false: case not Caz^[ACol*9+ARow].Monarq of
           true : Font.Color:=$00F0E7DD;
           false: Font.Color:=$0021170E;
           end;
    end;
    case (ACol div 3 + ARow div 3)mod 2 of
    //les rgions adjacentes ont des couleurs lgrement diffrentes
    0: Brush.Color:=$00AC7C51;
    1: Brush.Color:=$00BE946C;
    end;
    FillRect(ARect);
    brush.style:=bsclear;
    TextOut(ARect.Left+7,ARect.Top+1,MaGrille.Cells[ACol,ARow]);

    //lignes de dlimitation des rgions
    Pen.Color:=clBlack;
    case ACol of
    3,6: Pen.Width:=2;
    else Pen.Width:=1;
    end;
    Polyline([point(ARect.left-1,ARect.top),
              point(ARect.left-1,ARect.bottom+1)]);
    case ARow of
    3,6: Pen.Width:=2;
    else Pen.Width:=1;
    end;
    Polyline([point(ARect.left-1,ARect.top-1),
              point(ARect.Right,ARect.Top-1)]);
  end;
end;

procedure TMaGrille.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  iCaz:TiCaz;
  c,l:longint;
  v:TVal;
  b:0..9;
begin
  MaGrille.Cursor:=cr0;
  if(EtatGrille=Nvell)
  //gestion du curseur et de l'info (PanelRapport) en mode GRILLE/NOUVELLE
  then begin
         MaGrille.MouseToCell(X,Y,c,l);
         iCaz:=c*9+l;

         v:=0;
         for b:=0 to Form1.PanelModifGrille.ControlCount-1 do
         if(Form1.PanelModifGrille.Controls[b] as TSpeedButton).Down
         then v:=(Form1.PanelModifGrille.Controls[b] as TSpeedButton).Tag;

         case v of
         0: if Caz^[iCaz].Monarq
            //le btn effacer est down (sb0): curseur ad hoc si monarque dans la case
            then MaGrille.Cursor:=crx
            else MaGrille.Cursor:=cr0;
         1..9: //1 des boutons valeur (1  9) est down
           case Caz^[iCaz].Monarq of
           true : //aucune action possible si monarque dans la case
             begin
               MaGrille.Cursor:=cr0;
               Form1.PanelRapport.Caption:='';
             end;
           false: //si la case contient 1 ou + candidat (pas un monarque !)
             case v in Caz^[iCaz].Cdt of
             true : //la case peut contenir v
               begin
                 MaGrille.Cursor:=v;
                 Form1.PanelRapport.Caption:='';
               end;
             false: //la case ne peut pas contenir v
               begin
                 MaGrille.Cursor:=cr0;
                 with Form1.PanelRapport do
                 begin
                   Font.Color:=$000000D2;
                   Caption:='Valeur '+inttostr(v)+' interdite dans cette case';
                 end;
               end;
             end;
           end;
         end;
       end;
end;

procedure TMaGrille.MouseUp(Button:TMouseButton;Shift:TShiftState;X,Y:Integer);
var
  iCaz,nCaz:TiCaz;
begin
  with MaGrille do
  begin
    iCaz:=Col*9+Row;
    case Cursor of
    //validation de la saisie en mode GRILLE/NOUVELLE
    cr1,cr2,cr3,cr4,cr5,cr6,cr7,cr8,cr9: Caz^[iCaz].Cdt:=[ord(cursor)];//validation d'un monarque
    crx: begin //suppression d'un monarque
           Caz^[iCaz].Cdt:=[1..9];
           Caz^[iCaz].Err:=false;
           for nCaz:=0 to 80 do
           if not Caz^[nCaz].Monarq
           //remettre tous les candidats dans les cases non monarque
           //prpare l'appel  ElireCandidatsSeuls
           then Caz^[nCaz].Cdt:=[1..9];
         end;
    else exit;
    end;

    case Caz^[iCaz].Cdt=[1..9] of
    true : begin
             Cells[Col,Row]:='';
             Caz^[iCaz].Monarq:=false;
           end;
    false: begin
             Cells[Col,Row]:=inttostr(PremVal(Caz^[Col*9+Row].Cdt));
             Caz^[iCaz].Monarq:=true;
           end;
    end;
  end;
  ElireCandidatsSeuls;
  Form1.GererAffichage;
end;

procedure TMaGrille.CMMouseLeave(var Msg:TMessage);
begin
  if EtatGrille=Nvell
  then Form1.PanelRapport.Caption:='';
end;

procedure TForm1.DefinirZonesDesCases;
var
  iCaz:0..80;
begin
  //dfinir l'ensemble des 3 zones (colonne, ligne, rgion) auxquelles appartient chaque case
  for iCaz:=0 to 80 do
  begin
    ZoneCaz[iCaz,0]:=iCaz div 9; //colonne
    ZoneCaz[iCaz,1]:=iCaz mod 9+9; //ligne
    ZoneCaz[iCaz,2]:=(iCaz div 3)mod 3+(iCaz div 27)*3+18; //rgion
    Caz^[iCaz].Zon:=[ZoneCaz[iCaz,0]]+[ZoneCaz[iCaz,1]]+[ZoneCaz[iCaz,2]];
  end;
end;

procedure TForm1.DefinirCasesDesZones;
var
  c:0..8;
  iZon:TiZon;
begin
  //dfinir les indices des 9 cases de chacune des 26 zones
  //colonnes
  for iZon:=0 to 8 do
  for c:=0 to 8 do
  IndCaz[iZon,c]:=iZon*9+c;
  //lignes
  for iZon:=9 to 17 do
  for c:=0 to 8 do
  IndCaz[iZon,c]:=c*9+(iZon mod 9);
  //rgions
  for iZon:=18 to 26 do
  for c:=0 to 8 do
  IndCaz[iZon,c]:=(c div 3)*9+c mod 3+(iZon mod 18)*3+((iZon mod 18)div 3)*18;
end;

procedure TForm1.DefinirClnLgnDesRegions;
var
  cl:0..2;
  r:18..26;
begin
  //dfinir les 3 colonnes et 3 lignes communes  chaque rgion
  for r:=18 to 26 do
  for cl:=0 to 2 do
  begin
    RegCln[r,cl]:=((r-18)div 3)*3+cl;   //colonne
    RegLgn[r,cl]:=((r-18)mod 3)*3+9+cl;  //ligne
  end;
end;

procedure TForm1.GererAffichage;
var
  b:0..9;
begin
  MenSauve.Enabled:=(EtatGrille=Nvell)or(EtatGrille=Charg);
  MenResoud.Enabled:=(EtatGrille=Nvell)or(EtatGrille=Charg);
  MenVerif.Enabled:=not(EtatGrille=Nulle);
  BtnSolve.Enabled:=MenResoud.Enabled;
  for b:=0 to PanelModifGrille.ControlCount-1 do
  PanelModifGrille.Controls[b].Enabled:=(EtatGrille=Nvell);
end;

function AjustPath(APath:shortstring;MonControl:TControl):shortstring;
//renvoie le chemin APath ajust  la largeur du Canvas de MonControl
//(le chemin est au besoin tronqu pour laisser voir le nom du fichier)
var
  LgText:byte;
  MonCanvas:TControlCanvas;
begin
  MonCanvas:=TControlCanvas.Create;
  try
    MonCanvas.Control:=MonControl;
    if MonCanvas.TextWidth(APath)>MonControl.Width-10
    then begin
           LgText:=length(APath)-length('...\'+ExtractFileName(APath));
           repeat
             result:=leftstr(APath,LgText)+'...\'+ExtractFileName(APath);
             dec(LgText);
           until MonCanvas.TextWidth(result)<MonControl.Width-10;
         end
    else result:=APath;
  finally
    MonCanvas.Free;
  end;
end;

function PremVal(EnsVal:TEnsVal):TVal;
//renvoie le premier lment d'un ensemble de type TEnsVal
var
  v:TVal;
begin
  result:=0;
  for v:=1 to 9 do
  if v in EnsVal
  then begin
         result:=v;
         exit;
       end;
end;

function NbVal(EnsVal:TEnsVal):byte;
//renvoie le nombre d'lments d'un ensemble de type TEnsVal
var
  v:TVal;
begin
  result:=0;
  for v:=1 to 9 do
  if v in EnsVal
  then inc(result);
end;

function PremCaz(EnsCaz:TEnsCaz):TiCaz;
//renvoie le premier lment d'un ensemble de type TEnsCaz
var
  iCaz:TiCaz;
begin
  result:=0;
  for iCaz:=0 to 80 do
  if iCaz in EnsCaz
  then begin
         result:=iCaz;
         exit;
       end;
end;

function NbCaz(EnsCaz:TEnsCaz):byte;
//renvoie le nombre d'lments d'un ensemble de type TEnsCaz
var
  iCaz:TiCaz;
begin
  result:=0;
  for iCaz:=0 to 80 do
  if iCaz in EnsCaz
  then inc(result);
end;

procedure TForm1.OuvrirGrille;
var
  ListGrille:TStringList;
  c,l:0..8;
  iCaz:TiCaz;
  ValInit:TVal;
begin
  ListGrille:=TStringList.Create;
  try
    try
      OpenDialog.FileName:='';
      OpenDialog.Execute;
      JeuEnCours:=OpenDialog.FileName;
      ListGrille.LoadFromFile(JeuEnCours);
      //initialiser les valeurs
      for l:=0 to 8 do
      for c:=0 to 8 do
      begin
        iCaz:=c*9+l; //indice 0..80 de la case en fonction de la place dans ListGrille
        ValInit:=strtoint(ListGrille[l][c+1]);
        case ValInit=0 of
        true:  begin
                 Caz^[iCaz].Cdt:=[1..9];    //tous les candidats si case vide
                 Caz^[iCaz].Monarq:=false;
               end;
        false: begin
                 Caz^[iCaz].Cdt:=[ValInit]; //un seul candidat
                 Caz^[iCaz].Monarq:=true;
               end;
        end;
      end;
      RemplirGrille;
      for iCaz:=0 to 80 do
      Caz^[iCaz].Err:=false; //initialiser toutes les cases  valide
      EtatGrille:=Charg;
      if GrilleOK
      then ElireCandidatsSeuls
      else begin
             ChercherErreurs;
             MessageDlg('La grille comporte des erreurs (couples de valeurs rouges)',mtError,[mbOK],0);
             EtatGrille:=Erron;
           end;
      StatusBarAdr.Panels[0].Text:=AjustPath(JeuEnCours,StatusBarAdr);
      GererAffichage;
    finally
      ListGrille.Free;
    end;
  except
    on EconvertError do
    MessageDlg(JeuEnCours+chr(10)+'n''est pas une grille de SUDOKU valide',mtError,[mbOK],0);
    on EFOpenError do
    exit;
  end;
end;

procedure TForm1.SauverGrille;
var
  ListGrille:TStringList;
  c,l:0..8;
begin
  ListGrille:=TStringList.Create;
  l:=0;
  try
    try
      repeat
        ListGrille.Add('');
        for c:=0 to 8 do
        begin
          if MaGrille.Cells[c,l]=''
          then ListGrille[l]:=ListGrille[l]+'0'
          else ListGrille[l]:=ListGrille[l]+MaGrille.Cells[c,l];
        end;
        inc(l);
      until l=9;
      SaveDialog.Execute;
      ListGrille.SaveToFile(SaveDialog.FileName);
      JeuEnCours:=SaveDialog.FileName;
      StatusBarAdr.Panels[0].Text:=AjustPath(JeuEnCours,StatusBarAdr);
    except
      on EFCreateError do
      exit;
    end;
  finally
    ListGrille.Free;
  end;
end;


procedure TForm1.ViderGrille;
var
  iCaz:TiCaz;
begin
  for iCaz:=0 to 80 do
  begin
    Caz^[iCaz].Monarq:=false;
    Caz^[iCaz].Cdt:=[1..9];
    Caz^[iCaz].Err:=false;
  end;
  RemplirGrille;
end;

procedure TForm1.RemplirGrille;
var
  c,l:0..8;
begin
  for c:=0 to 8 do
  for l:=0 to 8 do
  begin
    if(NbVal(Caz^[c*9+l].Cdt)=1)
    then MaGrille.Cells[c,l]:=inttostr(PremVal(Caz^[c*9+l].Cdt))
    else MaGrille.Cells[c,l]:='';
  end;
end;

procedure TForm1.MenNouvClick(Sender: TObject);
begin
  with (Sender as TMenuItem) do
    case Tag of
    0: //nouvelle grille
       begin
         PanelRapport.Caption:='';
         StatusBarAdr.Panels[0].Text:='';
         ViderGrille;
         EtatGrille:=Nvell;
         sb1.Down:=true;
       end;
    1: //Ouvrir une grille
       begin
         PanelRapport.Caption:='';
         OuvrirGrille;
       end;
    2: //sauvegarder la grille
       begin
         SauverGrille;
         EtatGrille:=Charg;
       end;
    3: //vrifier la grille
       if GrilleOK
       then showmessage('Grille correcte')
       else begin
              ChercherErreurs;
              MessageDlg('La grille comporte des erreurs (couples de valeurs rouges)',mtError,[mbOK],0);
              EtatGrille:=Erron;
            end;
    end;
  GererAffichage;
end;

procedure TForm1.MenResoudClick(Sender: TObject);
Var
  FFrequency    : Int64    ;    // Frquence du compteur hautes performances
  FStart, FStop : Int64    ;    // Valeurs du compteur au dbut et  la fin du chrono
  FElapsed      : Extended ;    // Dure finale, en secondes
  TextModeReso:shortstring;
begin
  EchecReso:=false;
  PanelRapport.Font.Color:=clBlack;
  If Not QueryPerformanceFrequency(FFrequency) Then
     Raise Exception.Create('Pas de compteur hautes performances');
  QueryPerformanceCounter(FStart) ;
  ResolutionLogic;

  if not GrilleResolue
  then begin
         Timer.Enabled:=true;
         ResolutionParHypotheses;
         if GrilleResolue
         then TextModeReso:='par analyse d''hypothses';
         Timer.Enabled:=false;
       end
  else TextModeReso:='par la logique seule';
  QueryPerformanceCounter(FStop) ;
  FElapsed := (FStop-FStart)/FFrequency ;

  case EchecReso of
  true : PanelRapport.Caption:='La grille n''a pas pu tre rsolue';
  false: begin
           PanelRapport.Caption:='Grille rsolue '+TextModeReso+' en '
                                +FormatFloat('0.000',FElapsed*1000)+' millisec.';
           RemplirGrille;
         end;
  end;
  MaGrille.Cursor:=cr0;
  EtatGrille:=Solve;
  GererAffichage;
end;

procedure TForm1.MenQuittClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  EchecReso:=true;
end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  resize:=false;
end;

end.

